/*********************************************************************************/
/* Optimized and multithreaded matrix product                                    */
/* S. Vialle - December 2019                                                     */
/*********************************************************************************/

/*-------------------------------------------------------------------------------*/
/* CONSTANTS.                                                                    */
/*-------------------------------------------------------------------------------*/

//Matrix size -------------------
//#define SIZE            1024
#define SIZE            2048
//#define SIZE            4096
//#define SIZE            8192

//#define SIZE            1027
//#define SIZE            2050
//#define SIZE            4099


// Number of computing kernels --
#define NB_KERNELS 6


// Default values ---------------
#define DEFAULT_NB_THREADS  1
#define DEFAULT_KERNEL_ID   0
#define DEFAULT_PARLOOP_ID 'i'


/*-------------------------------------------------------------------------------*/
/* Global variable declarations.                                                 */
/*-------------------------------------------------------------------------------*/

/* Matrixes: C = A.B                                                             */
/* We use the Transposed B matrix, in place of B, to improve cache memory usage. */
extern double A[SIZE][SIZE];                   
extern double B[SIZE][SIZE];
extern double TB[SIZE][SIZE];
extern double C[SIZE][SIZE];

/* Global variables to control computations.                                     */
extern int NbThreads;
extern int KernelId;
extern char ParLoopId;


/*-------------------------------------------------------------------------------*/
/* Function declarations.                                                        */
/*-------------------------------------------------------------------------------*/
void LocalMatrixProduct();

